#!/usr/bin/env python

from ogsadai import *

class DSWrap:
	def __init__(self, uri, proxy = None, db = None, **kw):
		self.proxy = proxy
		self.uri = uri

		self.db = db
		if self.db:
			epr = EPRWrap(db)
			epr.uri = uri
			kw["endPointReference"] = epr
			kw["wsAddressURI"] = wsauri
		if proxy:
			kw["transdict"] = {'cert_file':proxy,'key_file':proxy}

		self.port = ds.DataServicePortTypeSOAPBindingSOAP(uri, **kw)
	def version(self):
		return self.port.getVersion(ds.GetVersionInputMessage()).get_element_version().encode('utf-8')

	def resources(self):
		req = ds.ListResourcesInputMessage()
		req._void = ""
		return map (lambda s: s.encode('utf-8'), self.port.listResources(req).get_element_resource())

	def query(self, q):
		req = ds.PerformInputMessage()
		req.PerformDocument = req.new_performDocument()

		sql = SQLQuery("sql-name", query = q)
		r2x = SQL2XML("r2x-name", chain = sql)

		req.PerformDocument.Any = PerformWrap()
		req.PerformDocument.Any.Activity = [sql.soap(), r2x.soap()]

		return self.port.perform(req).Result.Any.Result[2]._text.encode("utf-8")

